/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 */

#ifndef __PIDHASH_H
#define __PIDHASH_H

#include <sys/types.h>

struct pidhash_entry {
    pid_t pid;
    char *pname;
    int len;
    struct pidhash_entry *next;
    struct pidhash_entry *prev;
};

struct pidhash {
    int size;
    struct pidhash_entry buckets[0];
};

struct pidhash *pidhash_create(int buckets);
void pidhash_destroy(struct pidhash *hash);
struct pidhash_entry *pidhash_lookup(struct pidhash *hasht, pid_t pid);
struct pidhash_entry *pidhash_add_entry(struct pidhash *hasht, pid_t pid, char *pname, int len, struct pidhash_entry *current);

#endif
